<?php

class QuantikUIGenerator extends AbstractUIGenerator{
    protected function getButtonClass(PieceQuantik $piece): string{
       return "<button type='submit' name='active' disabled > $piece </button>";
    }

    protected function getDivPlateauQuantik(PlateauQuantik $plateau): string{
        $html = "<div class='plateau'>";
        $html.= "<table>";
        for ($i = 0; $i < 4; $i++){
            $html.="<tr>";
            for($j = 0; $j < 4; $j++){
                $html.= "<td>".$plateau->getPiece($i, $j)->__toString()."</td>";
            }
            $html.="</tr>";
        }
        $html.="</table></div>";
        return $html;
    }

    protected function getDivPiecesDisponibles(ArrayPieceQuantik $apq):string
    {
        $html="";
        foreach ($apq as $piece){
            $html.= "<button type='submit' name='$piece->getForme().$piece->getCouleur()' disabled >$piece->__toString()</button>"; //eventuellement modifier nom
        }
        return $html;
    }


    protected function getFormSelectionPiece(ArrayPieceQuantik $apq):string{
        $html = "<form action='traiteFormQuantik.php' method='get'>";
        $i = 0;
        foreach ($apq as $piece) {
            $html .= "<button type='submit' name='$i' >$piece</button>";
            $i++;
        }

        $html.="</form>";
        return $html;
    }
    
    protected function getFormPlateauQuantik(PlateauQuantik $plateau, PieceQuantik $piece):string
    {
        $html= "<form action='traiteFormQuantik.php' method='get'>";
        $action = new ActionQuantik($plateau);
        for($i =0; $i < 4; $i++){
            for($j = 0; $j < 4; $j++){
                if($action->isValidePose($i,$j, $piece)){
                    $html.="<button type='submit' class='vert' name='$i.:$j'>$piece</button>"; //: pour pouvoir split les coords
                }
                else{
                    $html.="<button type='submit' class='rouge' name='$i.$j' disabled>$piece</button>";
                }
            }
        }
        $html.="</from>";
        return $html;
    }
}